/******* Ultrasonic sensor *******/
/******* Programmer : Ho3ein Imani*******/

/* معرفی پین ها */
int trigPin = 12; //trigger pin
int echoPin = 11; // echo pin
long timeperiod, cm, inches; 

/* دستوراتی ک فقط یکبار نیاز به اجرا دارن*/
void setup()
{
  Serial.begin(9600); /*ارتباط پورت سریال
*/

  pinMode(trigPin, OUTPUT); /*تعریف تریگر به عنوان خروجی*/
  pinMode(echoPin, INPUT);  /* تعریف اکو به عنوان ورودی*/
}

/* قسمت اصلی برنامه*/
void loop()
{
  /* یک پالس 10 میکرو ثانیه ارسال میکنیم */
  digitalWrite(trigPin, LOW);
  delayMicroseconds(2);
  digitalWrite(trigPin, HIGH);
  delayMicroseconds(10);
  digitalWrite(trigPin, LOW);

  timeperiod = pulseIn(echoPin, HIGH);  /* یکپارچه سازی پالس*/

  inches = microsecondsToInches(timeperiod); /*تبدیل به اینچ*/
  cm = microsecondsToCentimeters(timeperiod); /* تبدیل به سانتیمتر*/
  Serial.print("distcance in inches=");
  Serial.print(inches);
  Serial.print("   distance in centimeters=");
  Serial.print(cm);
  Serial.println();
 
  
  delay(10);
} 
/* این کدها برای محاسبه فاصله استفاده میشوند*/
/* تابع محاسبه میکروثانیه به اینچ */ 
long microsecondsToInches(long microseconds)
{
  return microseconds / 74 / 2;
}

/* تابع محاسبه میکرو ثانیه به سانتیمتر */
long microsecondsToCentimeters(long microseconds)
{
    return microseconds / 29 / 2;
}

